Index: palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4256)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4270)
@@ -192,42 +192,38 @@
 !
 !-- Time stepping
-    dt_salsa           =   2.0, ! time step for calculating aerosol processes (s)
-    skip_time_do_salsa =  10.0, ! starting time of SALSA (s)
-
-!
-!-- Concentration initial types: 0 = based on the parameter file, 1 = read from a NetCDF file
-    init_aerosol_type  = 0, ! size distribution
-    init_gases_type    = 0, ! gases
-
-!
-!-- If isdtyp = 0, define the initial aerosol size distribution by dpg, sigmag and n_lognorm
-    dpg       = 13.5E-9, 54.0E-9, 864.1E-9, ! mean diameter per mode (in metres)
-    sigmag    =     1.8,    2.16,     2.21, ! standard deviation per mode 
-    n_lognorm =  1.43E9,  4.45E8,    7.0E4, ! number concentration per mode (#/m3)
-
-!
-!-- If igctyp = 0, apply these initial gas concentrations			
-    H2SO4_init = 5.0E12, ! sulphuric acid (#/m3)
-    HNO3_init  = 3.0E12, ! nitric acid (#/m3)
-    NH3_init   = 6.0E12, ! ammonia (#/m3)        
-    OCNV_init  = 1.0E12, ! non-volatile organic gases (#/m3)
-    OCSV_init  = 1.0E12, ! non-volatile organic gases (#/m3)
+    dt_salsa             =   2.0, ! time step for calculating aerosol processes (s)
+    skip_time_do_salsa   =  10.0, ! starting time of SALSA (s)
+
+!
+!-- If initializing_actions includes 'set_constant_profiles' , 
+!-- define the initial aerosol size distribution by dpg, sigmag and n_lognorm
+    dpg                  = 13.5E-9, 54.0E-9, 864.1E-9, ! mean diameter per mode (in metres)
+    sigmag               =     1.8,    2.16,     2.21, ! standard deviation per mode 
+    n_lognorm            =  1.43E9,  4.45E8,    7.0E4, ! number concentration per mode (#/m3)
+
+!
+!-- If initializing_actions includes 'set_constant_profiles', apply these initial gas concentrations			
+    H2SO4_init           = 5.0E12, ! sulphuric acid (#/m3)
+    HNO3_init            = 3.0E12, ! nitric acid (#/m3)
+    NH3_init             = 6.0E12, ! ammonia (#/m3)        
+    OCNV_init            = 1.0E12, ! non-volatile organic gases (#/m3)
+    OCSV_init            = 1.0E12, ! non-volatile organic gases (#/m3)
 
 !
 !-- List of activated chemical components: 
 !-- NOTE! Chemical species have to be activated here even if they are not initially present!
-    listspec = 'OC','NO','NH','','','','',  ! List of actived aerosols        
-    ! listspec = 'SO4','OC','BC','DU','SS','NO','NH', 
+    listspec             = 'OC','NO','NH','','','','',       
+    ! listspec             = 'SO4','OC','BC','DU','SS','NO','NH', 
 
 !
 !-- Sectional presentation of the particle size distribution
-    reglim = 3.0E-9, 1.0E-8, 2.5E-6, ! limits of the subranges (m)
-    nbin   = 1, 7,                   ! number of bins per subrange 
+    reglim               = 3.0E-9, 1.0E-8, 2.5E-6, ! limits of the subranges (m)
+    nbin                 = 1, 7,                   ! number of bins per subrange 
 !-- NOTE! Subrange 1 consists only of H2SO4 and/or OC
-    nf2a   = 1.0,	             ! Number fraction allocated to subrange 2a (b-bins will get 1-nf2a) 
+    nf2a                 = 1.0,	                   ! Number fraction allocated to subrange 2a 
 
 !
 !-- Aerosol emissions:
-    salsa_emission_mode = 'read_from_file', ! 'no_emission','uniform' or 'read_from_file'
+    salsa_emission_mode  = 'read_from_file', ! 'no_emission','uniform' or 'read_from_file'
 !-- NOTE! chemical components of the source have to be activated in 'listspec' 
 !--       and have to be in the same order
@@ -235,6 +231,6 @@
 !
 !-- If isdtyp = 0, set the chemical composition of the initial particle size distribution
-    mass_fracs_a = 0.8, 0.1, 0.1, 0.0, 0.0, 0.0, 0.0, ! mass fractions of chemical components: soluble 
-    mass_fracs_b = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, ! mass fractions of chemical components: insoluble
+    mass_fracs_a         = 0.8, 0.1, 0.1, 0.0, 0.0, 0.0, 0.0, ! mass fractions of soluble components
+    mass_fracs_b         = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, ! mass fractions of insoluble components
 !-- NOTE! Set everyhing to zero in mass_fracs_b if you do not want include insoluble species (default)
 
@@ -249,33 +245,35 @@
     decycle_salsa_ns     = .F.,
     decycle_method_salsa = 'dirichlet','dirichlet','dirichlet','dirichlet',  
-    bc_salsa_b     = 'neumann', !'dirichlet',  ! surface flux requires 'neumann'
-    bc_salsa_t     = 'dirichlet',  ! top
+    bc_salsa_b           = 'neumann',    ! surface flux requires 'neumann'
+    bc_salsa_t           = 'dirichlet',  ! top
 											   
 !
 !-- Switches for aerosol processes:
-    nldistupdate = .T., ! update aerosol size distribution
-    nldepo       = .T., ! Deposition master switch
-    nldepo_pcm   = .T., ! Deposition on vegetation
-    nldepo_surf  = .T., ! Deposition on walls
-    nlcnd        = .T., ! Condensation master switch
-    nlcndgas     = .T., ! Condensation of precursor gases
-    nlcndh2oae   = .F., ! Condensation of H2O on aerosols                          
-    nlcoag       = .T., ! Coagulation master switch
-    nsnucl       =  0,  ! Nucleation scheme (0 = off)
-    nj3          =  1,  ! J3 parametrization for nucleation 
-!
-!-- Deposition on vegetation (pcm = plant canopy model)
-    depo_pcm_par = 'zhang2001',  ! or 'petroff2010'
-!
-!-- Deposition on on ground, walls and roofs
-    depo_surf_par = 'zhang2001', ! or 'petroff2010'
-
+    nldistupdate         = .T., ! Update size distribution (default .T.)
+    nldepo               = .T., ! Deposition master switch
+    nldepo_pcm           = .T., ! Deposition on vegetation
+    nldepo_surf          = .T., ! Deposition on walls
+    nlcnd                = .F., ! Condensation master switch
+    nlcndgas             = .F., ! Condensation of precursor gases
+    nlcndh2oae           = .F., ! Condensation of H2O on aerosols
+    nlcoag               = .F., ! Coagulation master switch
+    nsnucl               =  0,  ! Nucleation scheme (0 = off)
+    nj3                  =  1,  ! J3 parametrization for nucleation 
+
+!
+!-- Deposition parametrisations:
+    depo_pcm_par         = 'zhang2001',  ! plant canopy
+    depo_surf_par        = 'zhang2001',  ! ground, roofs and walls
+    season_z01           = 5             ! Season for zhang2001, 
+                                         ! 1 = summer, 2 = autumn, 3 = late autumn
+                                         ! 4 = winter, 5 = transitional spring
 !
 !-- Other switches:
     advect_particle_water   = .T.,   ! particle water: advect or calculate at each dt_salsa 
     feedback_to_palm        = .F.,   ! feedback to flow due to condensation of water
-    nest_salsa              = .F.,   ! apply nesting for salsa
+    nest_salsa              = .F.,   ! apply self-nesting for salsa variables
     read_restart_data_salsa = .F.,   ! skip reading restart data even if it's done for the flow
     write_binary_salsa      = .F.,   ! skip writing restart data even if it's done for the flow
+    nesting_offline_salsa   = .F.,   ! apply offline nesting for salsa
          
  / ! end of salsa_par namelist
Index: palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc	(revision 4256)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc	(revision 4270)
@@ -1,10 +1,10 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4250M       *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 4269M       *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2019-10-07    Run:       urban_environment_salsa           
- Time:                 12:41:32    Run-No.:   00
- Run on host:             salsa
+ Date:               2019-10-23    Run:       urban_environment_salsa           
+ Time:                 13:00:08    Run-No.:   00
+ Run on host:           default
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
  ------------------------------------------------------------------------------
@@ -268,8 +268,4 @@
     Aerosol dynamic processes included: 
 
-       coagulation
-
-       condensation (of precursor gases = T and water vapour = F)
-
        dry deposition (on vegetation = T and on topography = T)
 
@@ -277,5 +273,4 @@
     Number of size bins for each aerosol subrange:   1  7
     Aerosol bin limits (in metres):  0.00E+000 0.00E+000 0.00E+000 0.00E+000 0.00E+000 0.00E+000 0.00E+000 0.00E+000
-    Initial number concentration in bins at the lowest level (#/m**3): 1.19E+008 9.63E+008 5.30E+008 1.96E+008 6.13E+007 6.01E+006 1.95E+005 1.25E+004
 
     Number of chemical components used: 3
@@ -294,9 +289,8 @@
 
    Initialising concentrations: 
-      Aerosol size distribution: init_aerosol_type = 0
-      Gas concentrations: init_gases_type = 0
-      Mode diametres: dpg(nmod) =   0.000  0.000  0.000  0.000  0.000  0.000  0.000 (m)
-      Standard deviation: sigmag(nmod) =    1.80   2.16   2.21   2.00   2.00   2.00   2.00
-      Number concentration: n_lognorm(nmod) =  1.4300E+009 4.4500E+008 7.0000E+004 0.0000E+000 0.0000E+000 0.0000E+000 0.0000E+000 (#/m3)
+      Aerosol size distribution: init_aerosol_type = 1
+      Gas concentrations: init_gases_type = 1
+
+      Size distribution read from a file.
 
    Emissions: salsa_emission_mode = read_from_file      