Index: palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4306)
+++ palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4307)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Activated output of iPT
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -1190,5 +1193,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  agt_time_count, end_time, message_string,                    &
+           ONLY:  agt_time_count, biometeorology, end_time, message_string,    &
                   multi_agent_system_end, multi_agent_system_start
 
@@ -1402,20 +1405,25 @@
                                   count = (/ out_noa /) )
           CALL netcdf_handle_error( 'mas_data_output_agents', 7 )
-          CALL cpu_log( log_point_s(17), 'mas_data_output', 'stop' )
-
-
-!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(6), agents%pm10,      &
-!                                   start = (/ 1, agt_time_count /),             &
-!                                   count = (/ out_noa /) )
-!           CALL netcdf_handle_error( 'mas_data_output_agents', 8 )
-! 
-!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(7), agents%pm25,      &
+
+
+          IF ( biometeorology )  THEN
+             nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(7), agents%ipt,    &
+                                     start = (/ 1, agt_time_count /),          &
+                                     count = (/ out_noa /) )
+             CALL netcdf_handle_error( 'mas_data_output_agents', 8 )  
+          ENDIF
+          
+
+          
+!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(8), agents%pm10,      &
 !                                   start = (/ 1, agt_time_count /),             &
 !                                   count = (/ out_noa /) )
 !           CALL netcdf_handle_error( 'mas_data_output_agents', 9 )
 ! 
-!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(8), agents%therm_comf,&
+!           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(9), agents%pm25,      &
 !                                   start = (/ 1, agt_time_count /),             &
 !                                   count = (/ out_noa /) )
+!           CALL netcdf_handle_error( 'mas_data_output_agents', 10 )
+! 
 ! 
 !           nc_stat = NF90_PUT_VAR( id_set_agt, id_var_agt(9), agents%uv,        &
@@ -1423,4 +1431,7 @@
 !                                   count = (/ out_noa /) )
 !           CALL netcdf_handle_error( 'mas_data_output_agents', 10 )
+
+          CALL cpu_log( log_point_s(17), 'mas_data_output', 'stop' )
+
 
 #endif
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4306)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4307)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Adjusted output of multi-agent system for biometeorology
+! 
+! 4227 2019-09-10 18:04:34Z gronemeier
 ! Replace function date_time_string by call to get_date_time
 ! 
@@ -139,6 +142,6 @@
           (/ 'ag_id           ', 'ag_x            ', 'ag_y            ',       &
              'ag_wind         ', 'ag_temp         ', 'ag_group        ',       &
-             'PM10            ', 'PM25            ', 'ag_iPT          ',       &
-             'ag_uv           ', 'not_used        ', 'not_used        ',       &
+             'ag_iPT          ', 'ag_PM10         ', 'ag_PM25         ',       &
+             'not_used        ', 'not_used        ', 'not_used        ',       &
              'not_used        ' /)
 
@@ -146,5 +149,5 @@
           (/ 'dim_less        ', 'meters          ', 'meters          ',       &
              'm/s             ', 'K               ', 'dim_less        ',       &
-             'tbd             ', 'tbd             ', 'tbd             ',       &
+             'C               ', 'tbd             ', 'tbd             ',       &
              'tbd             ', 'not_used        ', 'not_used        ',       &
              'not_used        ' /)
@@ -2355,10 +2358,11 @@
 !
 !--       Define vars for biometeorology
-          CALL netcdf_create_var( id_set_agt, (/ id_dim_agtnum,                &
-                                  id_dim_time_agt /), agt_var_names(9),        &
-                                  nc_precision(8), id_var_agt(9),              &
-                                  TRIM( agt_var_units(9) ),                    &
-                                  TRIM( agt_var_names(9) ), 339, 340, 341 )
-
+          IF ( biometeorology )  THEN
+             CALL netcdf_create_var( id_set_agt, (/ id_dim_agtnum,             &
+                                     id_dim_time_agt /), agt_var_names(7),     &
+                                     nc_precision(8), id_var_agt(7),           &
+                                     TRIM( agt_var_units(7) ),                 &
+                                     TRIM( agt_var_names(7) ), 339, 340, 341 )                      
+          ENDIF
 !
 !--       Leave netCDF define mode